/*
This program is confidential and proprietary to MRJ Technology Solutions
and may not be reproduced, published or disclosed to others without
written authorization from MRJ.

Copyright (c) 1998 MRJ Technology Solutions, Inc. All Rights Reserved.

This program is derived from prior work some of which was originally
written as a joint project between the Numerical Aerospace Simulation
(NAS) Systems Division of NASA Ames Research Center and the National
Energy Research Supercomputer Center (NERSC) of Lawrence Livermore
National Laboratory.
*/
/*************************************************************
*      myname           CodeGen.h
*      created          12/18/1996
*      updated          12/18/1996
*      works            xx/1996
*
*		designer		rrs/1996
*************************************************************/

/***********************************************************
*
*	               OPERATION OVERVIEW
*
*
************************************************************/
#ifndef _CODEGEN_H
#define _CODEGEN_H
/* Feature test switches */
#ifndef _POSIX_SOURCE
#define _POSIX_SOURCE 1
#endif  /* _POSIX_SOURCE */

#if __STDC__ == 1
/*
 * The following macro definations take affect when compiling under ansi C
 *
 * The A_ macro is provided for function prototype declarations.  It allows
 * ANSI C prototypes to be complied under K&R C
 */

#define A_(x) x

#else
/* The following macro definations take affect when compiling under K&R C */

#define const
#define volatile
#define A_(x) ()

#endif  /* __STDC__ */

#include "List.h"

struct Stack
{
	Np     np;
        struct Stack *rptr;
};
typedef struct Stack *St;
 
/*prototypes*/

extern void
CodeGenInit A_((void));

extern void
CodeGenPutDF A_((int df));

extern void
CodeGenCondPrint A_((char *str));

extern void
CodeGenPrint A_((void));

extern void
CodeGenErr A_((int e));

extern void
CodeGenBuffClear A_((void));

extern void
CodeGenBuffPrint A_((void));

extern void
CodeGenBuffEmit A_((void));

extern void
CodeGenBuffSwitchEmit A_((void));

extern void
CodeGenBuffSave A_((char *str));

extern void
CodeGenBuffSaveBefore A_((char *str, char *lexeme, int level));

extern void
CodeGenBuffSaveAfter A_((char *str, char *lexeme, int level));

extern void
CodeGenBuffSaveFirst A_((char *str));

extern void
CodeGenBuffSaveFun A_((char *str));

extern void
CodeGenBuffSaveFunBefore A_((char *str, char *lexeme, int level));

extern void
CodeGenBuffSaveFunAfter A_((char *str, char *lexeme, int level));

extern void
CodeGenBuffSaveFunFirst A_((char *str));

extern void
CodeGenStatPrint A_((void));

extern void
CodeGenStatPrintTail A_((struct MYTOK data));

extern void
CodeGenDefSimple A_((struct MYTOK data));

extern void
CodeGenProgHead A_((void));

extern int
CodeGenLastDef A_((char *lexeme));

extern void
CodeGenStackClear A_((void));

extern St
CodeGenStackNew A_((Np np));

extern void
CodeGenStackPush A_((Np	np));

extern Np
CodeGenStackPop A_((void));

extern void
CodeGenStackPrint A_((void));

extern void
CodeGenBuffSaveSpecOper A_((char *operstr));

extern Np
CodeGenBuffGetLast A_((void));

extern void
CodeGenBuffDelete A_((char *lexeme, int inst));

extern void
CodeGenBuffSaveStrAssign A_((void));

extern void
CodeGenBuffSaveForeach A_((struct MYTOK var, struct MYTOK svar));

extern void
CodeGenBuffSaveSwitch A_((struct MYTOK switchVar));

extern void
CodeGenBuffSaveSwitchIn A_((struct MYTOK switchVar, struct MYTOK caseVal));

extern void
CodeGenBuffSaveQueJobFind A_((void));

extern void
CodeGenBuffSaveQueFilter A_((void));

extern Np
CodeGenBuffGetNp A_(( char *lexeme, int lineDef ));
#endif /* _CODEGEN_H */
